module WTOSC
  # Migration module
  # Include in an ActiveRecord::Migration to use

  module TypeFetcher
    DEFAULT_TYPES = {
      string: 'VARCHAR(255)'
    }

    def self.fetch(type)
      DEFAULT_TYPES[type] || type
    end
  end

  module MigrationHelper
    def queries
      @queries ||= []
    end

    # TODO: add more methods
    def add_column(table_name, column, type)
      query = {
        table: table_name.to_s,
        query: "ADD COLUMN #{column} #{TypeFetcher.fetch(type)}"
      }

      queries.push(query)
    end

    def migrate!(options = {})
      Executor.new(
        queries,
        WTOSC.configuration.default_options.merge(options),
        before: WTOSC.configuration.before_hooks,
        after: WTOSC.configuration.after_hooks
      ).execute!
    end
  end
end
